//+------------------------------------------------------------------+
//|                                                   X Axis(XY).mq4 |
//|                                                            MELSA |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "MELSA"
#property link      ""
#property version   "1.00"
#property strict

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern int M15Diff = 5;   
extern int M30Diff = 5;
extern int M60Diff = 5;
extern int M240Diff = 5; 
extern bool ClearAllObjects = false;
extern color TickerColor = Red;
extern color AveVolColor = Red;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
int NDigits = 4;   // this variable is here to support 5-digit brokers
int ObjCount = 0; 
int current = 0;

datetime BarTime = 0;


int init()
{
    NDigits = Digits;
    
    if (ClearAllObjects) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
    
    return (0);

}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryNewBar();
    
    return (0);
    
}

void OnEveryNewBar()
{
    PipValue = 1;
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    if (BarTime < Time[0])
    {
        // we have a new bar opened
        BarTime = Time[0]; // keep the new bar open time
        TechnicalAnalysis();
        
    }
}


void TechnicalAnalysis()
{
    if ( 
           ((Close[1] > Open[1]) && ((Close[1] - Open[1]) <=((M30Diff)*PipValue*Point))) 
        || ((Open[1] > Close[1]) && ((Open[1]-Close[1])   <=((M30Diff)*PipValue*Point)))  
        || (Close[1]== Open[1])
       )
    {
      VolumePattern1();  
      VolumePattern2();  
      VolumePattern3();  
    }
}



void VolumePattern1()
{
    if ((iVolume(NULL, NULL,1) > iVolume(NULL, NULL,2)) && (iVolume(NULL, NULL,2) > iVolume(NULL, NULL,3)) )
    {
        Ticker();
        
    }
}

void VolumePattern2()
{
    if ((iVolume(NULL, NULL,1) > iVolume(NULL, NULL,3)) && (iVolume(NULL, NULL,3) > iVolume(NULL, NULL,2)) )
    {
        Ticker();
        
    }
}

void VolumePattern3()
{
    if ((iVolume(NULL, NULL,2) > iVolume(NULL, NULL,3)) && (iVolume(NULL, NULL,3) > iVolume(NULL, NULL,4))
        && (iVolume(NULL, NULL,1) > iVolume(NULL, NULL,4))  )
    {
        Ticker();
        
    }
}

void Ticker()
{
    ObjCount += 1;
    string objName = "EAChart_" + (string)ObjCount;
    ObjectCreate(objName, OBJ_ARROW, 0, Time[1], Low[1]);
    ObjectSet(objName, OBJPROP_COLOR, TickerColor);
    ObjectSet(objName, OBJPROP_ARROWCODE,167);
    
}


int deinit()
{
    if (ClearAllObjects) ObjectsDeleteAll();
    
    return (0);
    
    
}

